Index: LMDZ6/branches/LMDZ_cdrag_LSCE/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_cdrag_LSCE/libf/phylmd/phys_output_write_mod.F90	(revision 4662)
+++ LMDZ6/branches/LMDZ_cdrag_LSCE/libf/phylmd/phys_output_write_mod.F90	(revision 4669)
@@ -17,5 +17,5 @@
   SUBROUTINE phys_output_write(itap, pdtphys, paprs, pphis, &
        pplay, lmax_th, aerosol_couple,         &
-       ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, ok_sync, &
+       ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, ibs, ok_sync, &
        ptconv, read_climoz, clevSTD, ptconvth, &
        d_u, d_t, qx, d_qx, zmasse, flag_aerosol, flag_aerosol_strat, ok_cdnc)
@@ -47,5 +47,6 @@
          o_psol, o_mass, o_qsurf, o_qsol, &
          o_precip, o_rain_fall, o_rain_con, o_ndayrain, o_plul, o_pluc, o_plun, &
-         o_snow, o_msnow, o_fsnow, o_evap, o_ep,o_epmax_diag, & ! epmax_cape
+         o_snow, o_msnow, o_fsnow, o_evap, o_snowerosion, o_ustart_lic, o_rhosnow_lic, o_bsfall, & 
+         o_ep,o_epmax_diag, & ! epmax_cape
          o_tops, o_tops0, o_topl, o_topl0, &
          o_SWupTOA, o_SWupTOAclr, o_SWupTOAcleanclr, o_SWdnTOA, o_fdiffSWdnSFC, &
@@ -81,5 +82,5 @@
          o_Mipsh, o_Ma, &
          o_dnwd, o_dnwd0, o_ftime_deepcv, o_ftime_con, o_mc, &
-         o_prw, o_prlw, o_prsw, o_s_pblh, o_s_pblt, o_s_lcl, &
+         o_prw, o_prlw, o_prsw, o_prbsw, o_s_pblh, o_s_pblt, o_s_lcl, &
          o_s_therm, o_uSTDlevs, o_vSTDlevs, &
          o_wSTDlevs, o_zSTDlevs, o_qSTDlevs, &
@@ -106,5 +107,5 @@
          o_weakinv, o_dthmin, o_cldtau, &
          o_cldemi, o_pr_con_l, o_pr_con_i, &
-         o_pr_lsc_l, o_pr_lsc_i, o_re, o_fl, &
+         o_pr_lsc_l, o_pr_lsc_i, o_pr_bs, o_re, o_fl, &
          o_rh2m, &
          o_qsat2m, o_tpot, o_tpote, o_SWnetOR, &
@@ -134,14 +135,15 @@
          o_cldicemxrat, o_cldwatmxrat, o_reffclwtop, o_ec550aer, &
          o_lwcon, o_iwcon, o_temp, o_theta, &
-         o_ovapinit, o_ovap, o_oliq, o_ocond, o_geop, &
+         o_ovapinit, o_ovap, o_oliq, o_ocond, o_geop,o_qbs, &
          o_vitu, o_vitv, o_vitw, o_pres, o_paprs, &
          o_zfull, o_zhalf, o_rneb, o_rnebjn, o_rnebcon, &
          o_rnebls, o_rneblsvol, o_rhum, o_rhl, o_rhi, o_ozone, o_ozone_light, &
+         o_pfraclr, o_pfracld, &
          o_duphy, o_dtphy, o_dqphy, o_dqphy2d, o_dqlphy, o_dqlphy2d, &
-         o_dqsphy, o_dqsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
+         o_dqsphy, o_dqsphy2d, o_dqbsphy, o_dqbsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
          o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, o_tke_dissip, &
          o_tke_max, o_kz, o_kz_max, o_clwcon, &
          o_dtdyn, o_dqdyn, o_dqdyn2d, o_dqldyn, o_dqldyn2d, & 
-         o_dqsdyn, o_dqsdyn2d, o_dudyn, o_dvdyn, &
+         o_dqsdyn, o_dqsdyn2d, o_dqbsdyn, o_dqbsdyn2d, o_dudyn, o_dvdyn, &
          o_dtcon, o_tntc, o_ducon, o_dvcon, &
          o_dqcon, o_dqcon2d, o_tnhusc, o_tnhusc, o_dtlsc, &
@@ -151,4 +153,5 @@
          o_ptconvth, o_lmaxth, o_dtvdf, &
          o_dtdis, o_dqvdf, o_dqvdf2d, o_dteva, o_dqeva, o_dqeva2d, &
+         o_dqbsvdf, o_dtbs, o_dqbs, o_dqbsbs, &
          o_ptconv, o_ratqs, o_dtthe, & 
          o_duthe, o_dvthe, o_ftime_th, &
@@ -204,4 +207,5 @@
          o_dxtajs,o_dxtvdf,o_dxtthe, o_dxtch4, &
          o_dxtprod_nucl,o_dxtcosmo,o_dxtdecroiss, &
+         o_xtevap_srf, &
 #endif
 ! Tropopause
@@ -219,5 +223,7 @@
          o_flx_co2_ff, o_flx_co2_bb, & 
          o_delta_sst, o_delta_sal, o_ds_ns, o_dt_ns, o_dter, o_dser, o_tkt, &
-         o_tks, o_taur, o_sss
+         o_tks, o_taur, o_sss, &
+!FC
+         o_zxfluxt,o_zxfluxq
 
 #ifdef CPP_StratAer
@@ -241,7 +247,7 @@
     USE phys_state_var_mod, ONLY: heat_volc, cool_volc !NL
 
-    USE phys_state_var_mod, ONLY: pctsrf, rain_fall, snow_fall, &
+    USE phys_state_var_mod, ONLY: pctsrf, rain_fall, snow_fall, bs_fall,&
          qsol, z0m, z0h, fevap, agesno, &
-         nday_rain, rain_con, snow_con, &
+         nday_rain, ndayrain_mth, rain_con, snow_con, &
          topsw, toplw, toplw0, swup, swdn, solswfdiff, &
          topsw0, swupc0, swdnc0, swup0, swdn0, SWup200, SWup200clr, &
@@ -269,5 +275,5 @@
          wTSTD, u2STD, v2STD, T2STD, missing_val_nf90, delta_sal, ds_ns, &
 #ifdef ISO
-        xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, &
+        xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, fxtevap, &
 #endif
          dt_ns, delta_sst, dter, dser
@@ -275,4 +281,5 @@
     USE phys_local_var_mod, ONLY: zxfluxlat, slp, ptstar, pt0, zxtsol, zt2m, &
          zn2mout, t2m_min_mon, t2m_max_mon, evap, &
+         snowerosion, zxustartlic, zxrhoslic, &
          l_mixmin,l_mix, tke_dissip, &
          zu10m, zv10m, zq2m, zustar, zxqsurf, &
@@ -288,5 +295,5 @@
          uwat, vwat, &
          rneb_seri, d_rneb_dyn, &
-         plcl, plfc, wbeff, convoccur, upwd, dnwd, dnwd0, prw, prlw, prsw, &
+         plcl, plfc, wbeff, convoccur, upwd, dnwd, dnwd0, prw, prlw, prsw,prbsw, &
          s_pblh, s_pblt, s_lcl, s_therm, uwriteSTD, &
          vwriteSTD, wwriteSTD, phiwriteSTD, qwriteSTD, &
@@ -308,5 +315,5 @@
          alp_bl_stat, alp_bl_fluct_tke, slab_wfbils, &
          weak_inversion, dthmin, cldtau, cldemi, &
-         pmflxr, pmflxs, prfl, psfl, re, fl, rh2m, &
+         pmflxr, pmflxs, prfl, psfl,bsfl, re, fl, rh2m, &
          qsat2m, tpote, tpot, d_ts, od443aer, od550aer, dryod550aer, &
          od865aer, abs550aer, od550lt1aer, sconcso4, sconcno3, &
@@ -324,9 +331,10 @@
          icc3dcon, icc3dstra, zfice, reffclwtop, &
          ec550aer, flwc, fiwc, t_seri, theta, q_seri, &
-         ql_seri, qs_seri, tr_seri, &
+         ql_seri, qs_seri, qbs_seri, tr_seri, qbs_seri,&
          zphi, u_seri, v_seri, omega, cldfra, &
-         rneb, rnebjn, rneblsvol, zx_rh, zx_rhl, zx_rhi, d_t_dyn,  & 
-         d_q_dyn,  d_ql_dyn, d_qs_dyn, &
-         d_q_dyn2d,  d_ql_dyn2d, d_qs_dyn2d, &
+         rneb, rnebjn, rneblsvol, zx_rh, zx_rhl, zx_rhi, &
+         pfraclr, pfracld, d_t_dyn,  & 
+         d_q_dyn,  d_ql_dyn, d_qs_dyn, d_qbs_dyn,  &
+         d_q_dyn2d,  d_ql_dyn2d, d_qs_dyn2d, d_qbs_dyn2d, &
          d_u_dyn, d_v_dyn, d_t_con, d_t_ajsb, d_t_ajs, &
          d_u_ajs, d_v_ajs, &
@@ -336,4 +344,5 @@
          d_t_lscst, d_q_lscth, d_q_lscst, plul_th, &
          plul_st, d_t_vdf, d_t_diss, d_q_vdf, d_q_eva, &
+         d_t_bs, d_q_bs, d_qbs_bs, d_qbs_vdf, &
          zw2, fraca, zmax_th, d_q_ajsb, d_t_ec, d_u_vdf, &
          d_v_vdf, d_u_oro, d_v_oro, d_t_oro, d_u_lif, &
@@ -350,5 +359,7 @@
 #endif
          ep, epmax_diag, &  ! epmax_cape
-         p_tropopause, t_tropopause, z_tropopause
+         p_tropopause, t_tropopause, z_tropopause, &
+         zxfluxt,zxfluxq
+!FC
 
 #ifdef CPP_StratAer 
@@ -431,5 +442,5 @@
 
     ! Input
-    INTEGER :: itap, ivap, iliq, isol, read_climoz
+    INTEGER :: itap, ivap, iliq, isol, ibs, read_climoz
     INTEGER, DIMENSION(klon) :: lmax_th
     LOGICAL :: aerosol_couple, ok_sync
@@ -887,12 +898,18 @@
 
        IF (vars_defined) THEN
-          DO i = 1, klon
+          IF (ok_bs) THEN
+             DO i = 1, klon
+             zx_tmp_fi2d(i) = rain_fall(i) + snow_fall(i) + bs_fall(i)
+             ENDDO
+          ELSE
+             DO i = 1, klon
              zx_tmp_fi2d(i) = rain_fall(i) + snow_fall(i)
-          ENDDO
+             ENDDO
+          ENDIF
        ENDIF
 
        CALL histwrite_phy(o_precip, zx_tmp_fi2d)
        CALL histwrite_phy(o_rain_fall, rain_fall)
-       CALL histwrite_phy(o_ndayrain, nday_rain)
+       CALL histwrite_phy(o_ndayrain, ndayrain_mth)
 
        ! epmax_cape:
@@ -919,4 +936,11 @@
        CALL histwrite_phy(o_fsnow, zfra_o)
        CALL histwrite_phy(o_evap, evap)
+
+       IF (ok_bs) THEN
+           CALL histwrite_phy(o_bsfall, bs_fall)     
+           CALL histwrite_phy(o_snowerosion, snowerosion)
+           CALL histwrite_phy(o_ustart_lic, zxustartlic)
+           CALL histwrite_phy(o_rhosnow_lic, zxrhoslic)
+       ENDIF
 
        IF (vars_defined) THEN
@@ -1105,15 +1129,4 @@
        ENDIF
        CALL histwrite_phy(o_tauy, zx_tmp_fi2d)
-
-       ! Etienne: test sorties pour compil sur JZ
-!       IF (landice_opt .GE. 1) THEN
-!          CALL histwrite_phy(o_snowsrf, snow_o)
-!          CALL histwrite_phy(o_qsnow, qsnow)
-!          CALL histwrite_phy(o_snowhgt,snowhgt)
-!          CALL histwrite_phy(o_toice,to_ice)
-!          CALL histwrite_phy(o_sissnow,sissnow)
-!          CALL histwrite_phy(o_runoff,runoff)
-!          CALL histwrite_phy(o_albslw3,albsol3_lic)
-!       ENDIF
 
        DO nsrf = 1, nbsrf
@@ -1281,4 +1294,7 @@
        CALL histwrite_phy(o_prlw, prlw)
        CALL histwrite_phy(o_prsw, prsw)
+       IF (ok_bs) THEN
+       CALL histwrite_phy(o_prbsw, prbsw)
+       ENDIF
        CALL histwrite_phy(o_s_pblh, s_pblh)
        CALL histwrite_phy(o_s_pblt, s_pblt)
@@ -1526,4 +1542,9 @@
        CALL histwrite_phy(o_re, re)
        CALL histwrite_phy(o_fl, fl)
+
+       IF (ok_bs) THEN
+         CALL histwrite_phy(o_pr_bs, bsfl(:,1:klev))
+       ENDIF
+
        IF (vars_defined) THEN
           DO i=1, klon
@@ -1783,4 +1804,8 @@
        CALL histwrite_phy(o_ovap, q_seri)
        CALL histwrite_phy(o_oliq, ql_seri)
+       !FC
+       CALL histwrite_phy(o_zxfluxt, zxfluxt)
+       CALL histwrite_phy(o_zxfluxq, zx_tmp_fi3d)
+       !FC
 
        IF (vars_defined) zx_tmp_fi3d = ql_seri+qs_seri
@@ -1796,4 +1821,8 @@
        IF (vars_defined) zx_tmp_fi3d = zphi/RG
        CALL histwrite_phy(o_zfull,zx_tmp_fi3d)
+
+       IF (ok_bs) THEN
+          CALL histwrite_phy(o_qbs, qbs_seri)
+       ENDIF
 
 #ifdef CPP_XIOS
@@ -1846,4 +1875,9 @@
           IF (vars_defined) zx_tmp_fi3d = zx_rhi * 100.
           CALL histwrite_phy(o_rhi, zx_tmp_fi3d)
+       ENDIF
+     
+       IF (ok_new_lscp) THEN
+           CALL histwrite_phy(o_pfraclr, pfraclr)
+           CALL histwrite_phy(o_pfracld, pfracld)
        ENDIF
 
@@ -1908,4 +1942,16 @@
        zx_tmp_fi2d=0.0
        CALL histwrite_phy(o_dqsphy2d,  zx_tmp_fi2d)
+       ENDIF
+
+
+       IF (ok_bs) THEN
+       CALL histwrite_phy(o_dqbsphy,  d_qx(:,:,ibs))
+       IF (vars_defined) CALL water_int(klon,klev,d_qx(:,:,ibs),zmasse,zx_tmp_fi2d)
+       CALL histwrite_phy(o_dqbsphy2d,  zx_tmp_fi2d)
+       ELSE
+       zx_tmp_fi3d=0.0
+       CALL histwrite_phy(o_dqbsphy,  zx_tmp_fi3d)
+       zx_tmp_fi2d=0.0
+       CALL histwrite_phy(o_dqbsphy2d,  zx_tmp_fi2d)
        ENDIF
 
@@ -1958,4 +2004,9 @@
 
        CALL histwrite_phy(o_dqsdyn2d, d_qs_dyn2d)
+
+       IF (ok_bs) THEN
+       CALL histwrite_phy(o_dqbsdyn, d_qbs_dyn)
+       CALL histwrite_phy(o_dqbsdyn2d, d_qbs_dyn2d)
+       ENDIF
 
        CALL histwrite_phy(o_dudyn, d_u_dyn)
@@ -2101,4 +2152,15 @@
        ENDIF
        CALL histwrite_phy(o_dvthe, zx_tmp_fi3d)
+
+       IF (ok_bs) THEN
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_qbs_vdf(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dqbsvdf, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_qbs_bs(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dqbsbs, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_q_bs(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dqbs, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_bs(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dtbs, zx_tmp_fi3d)
+       ENDIF
 
        IF (iflag_thermals>=1) THEN
@@ -2614,4 +2676,9 @@
         CALL histwrite_phy(o_xtoliq(ixt), xtl_seri(ixt,:,:))
 
+        DO nsrf = 1, nbsrf ! ajout Camille 8 mai 2023
+        IF (vars_defined)       zx_tmp_fi2d(1 : klon) = fxtevap(ixt,:, nsrf)
+        CALL histwrite_phy(o_xtevap_srf(ixt,nsrf), zx_tmp_fi2d)
+        ENDDO
+
         IF (vars_defined) zx_tmp_fi3d(:,:)=xtl_seri(ixt,:,:)+xts_seri(ixt,:,:)
         CALL histwrite_phy(o_xtcond(ixt), zx_tmp_fi3d)
Index: LMDZ6/branches/LMDZ_cdrag_LSCE/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_cdrag_LSCE/libf/phylmd/phys_state_var_mod.F90	(revision 4662)
+++ LMDZ6/branches/LMDZ_cdrag_LSCE/libf/phylmd/phys_state_var_mod.F90	(revision 4669)
@@ -54,6 +54,6 @@
 
 
-      REAL, ALLOCATABLE, SAVE :: rain_fall(:), snow_fall(:)
-!$OMP THREADPRIVATE( rain_fall, snow_fall)
+      REAL, ALLOCATABLE, SAVE :: rain_fall(:), snow_fall(:), bs_fall(:)
+!$OMP THREADPRIVATE( rain_fall, snow_fall, bs_fall)
       REAL, ALLOCATABLE, SAVE :: solsw(:), solswfdiff(:), sollw(:)
 !$OMP THREADPRIVATE(solsw, solswfdiff, sollw)
@@ -82,8 +82,8 @@
       REAL, ALLOCATABLE, SAVE :: t_ancien(:,:), q_ancien(:,:)
 !$OMP THREADPRIVATE(t_ancien, q_ancien)
-      REAL, ALLOCATABLE, SAVE :: ql_ancien(:,:), qs_ancien(:,:)
-!$OMP THREADPRIVATE(ql_ancien, qs_ancien)
-      REAL, ALLOCATABLE, SAVE :: prw_ancien(:), prlw_ancien(:), prsw_ancien(:)
-!$OMP THREADPRIVATE(prw_ancien, prlw_ancien, prsw_ancien)
+      REAL, ALLOCATABLE, SAVE :: ql_ancien(:,:), qs_ancien(:,:), qbs_ancien(:,:)
+!$OMP THREADPRIVATE(ql_ancien, qs_ancien, qbs_ancien)
+      REAL, ALLOCATABLE, SAVE :: prw_ancien(:), prlw_ancien(:), prsw_ancien(:), prbsw_ancien(:)
+!$OMP THREADPRIVATE(prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien)
 #ifdef ISO
       REAL, ALLOCATABLE, SAVE :: xt_ancien(:,:,:),xtl_ancien(:,:,:),xts_ancien(:,:,:)
@@ -313,4 +313,6 @@
       REAL,ALLOCATABLE,SAVE :: total_rain(:), nday_rain(:)  
 !$OMP THREADPRIVATE(total_rain,nday_rain)
+      REAL,ALLOCATABLE,SAVE :: ndayrain_mth(:)
+!$OMP THREADPRIVATE(ndayrain_mth)
       REAL,ALLOCATABLE,SAVE :: paire_ter(:)
 !$OMP THREADPRIVATE(paire_ter)
@@ -547,4 +549,5 @@
       ALLOCATE(rain_fall(klon))
       ALLOCATE(snow_fall(klon))
+      ALLOCATE(bs_fall(klon))
       ALLOCATE(solsw(klon), solswfdiff(klon), sollw(klon))
       sollw=0.0
@@ -556,6 +559,6 @@
       ALLOCATE(rugoro(klon))
       ALLOCATE(t_ancien(klon,klev), q_ancien(klon,klev))
-      ALLOCATE(ql_ancien(klon,klev), qs_ancien(klon,klev))
-      ALLOCATE(prw_ancien(klon), prlw_ancien(klon), prsw_ancien(klon))
+      ALLOCATE(ql_ancien(klon,klev), qs_ancien(klon,klev), qbs_ancien(klon,klev))
+      ALLOCATE(prw_ancien(klon), prlw_ancien(klon), prsw_ancien(klon), prbsw_ancien(klon))
       ALLOCATE(u_ancien(klon,klev), v_ancien(klon,klev))
 !!! Rom P >>>
@@ -655,4 +658,5 @@
       ALLOCATE(pfrac_1nucl(klon,klev))
       ALLOCATE(total_rain(klon), nday_rain(klon))
+      ALLOCATE(ndayrain_mth(klon))
       ALLOCATE(paire_ter(klon))
       ALLOCATE(albsol1(klon), albsol2(klon))
@@ -763,10 +767,10 @@
 !FC
       DEALLOCATE(treedrg)
-      DEALLOCATE(rain_fall, snow_fall, solsw, solswfdiff, sollw, radsol, swradcorr)
+      DEALLOCATE(rain_fall, snow_fall, bs_fall,solsw, solswfdiff, sollw, radsol, swradcorr)
       DEALLOCATE(zmea, zstd, zsig, zgam)
       DEALLOCATE(zthe, zpic, zval)
       DEALLOCATE(rugoro, t_ancien, q_ancien, clwcon, rnebcon)
-      DEALLOCATE(qs_ancien, ql_ancien, rneb_ancien)
-      DEALLOCATE(prw_ancien, prlw_ancien, prsw_ancien)
+      DEALLOCATE(qs_ancien, ql_ancien, qbs_ancien, rneb_ancien)
+      DEALLOCATE(prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien)
       DEALLOCATE(qtc_cv,sigt_cv)
       DEALLOCATE(u_ancien, v_ancien)
@@ -835,4 +839,5 @@
       DEALLOCATE(pfrac_1nucl)
       DEALLOCATE(total_rain, nday_rain)
+      DEALLOCATE(ndayrain_mth)
       DEALLOCATE(paire_ter)
       DEALLOCATE(albsol1, albsol2)
